unit ServerObjectImpl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, ServerObject_TLB, StdVcl;

type
  TTest = class(TAutoObject, ITest)
  private
    FCallbackObject: OleVariant;
  protected
    function Get_CallbackObject: OleVariant; safecall;
    procedure Set_CallbackObject(Value: OleVariant); safecall;
    procedure FireCallback; safecall;
  end;

implementation

uses ComServ;

function AsDisp(Instance: OleVariant): IDispatch;
begin
  if TVarData(Instance).VType = varDispatch then
    Result := IDispatch(TVarData(Instance).VDispatch)
  else if TVarData(Instance).VType = (varDispatch or varByRef) then
    Result := IDispatch(TVarData(Instance).VPointer^)
  else if TVarData(Instance).VType = (varVariant or varByRef) then
    Result := AsDisp(OleVariant(TVarData(Instance).VPointer^))
  else
    Result := nil;
end;

function TTest.Get_CallbackObject: OleVariant;
begin
  Result := AsDisp(FCallbackObject);
end;

procedure TTest.Set_CallbackObject(Value: OleVariant);
begin
  FCallbackObject := AsDisp(Value);
end;

procedure TTest.FireCallback;
begin
  FCallbackObject.Callback('Callback method was called successfully!');
end;

initialization
  TAutoObjectFactory.Create(ComServer, TTest, Class_Test,
    ciMultiInstance, tmApartment);
end.
